Unit Kub_TPU;
Interface
Const Ax=7;
      Ay=7;
      Az=7;
var bx,by:Integer;
    dvx,dvy,dvz,vx,vy,vz:array[1..8] of real;
    aa,bb:extended;

Procedure CordVec(x1,y1,z1,x2,y2,z2:real;var a1,b1,c1:real);
Procedure Detrm(a1,b1,c1,a2,b2,c2:real;var a3,b3,c3:real);
Procedure LineDraw(n1,n2:Byte);
Procedure GranDraw(n1,n2,n3,n4,c:Byte);
Procedure Set_Angl(paa,pbb:Real);
Procedure Kub(x,y:Integer;paa,pbb:Real);

Implementation
Uses Graph;

Procedure CordVec(x1,y1,z1,x2,y2,z2:real;var a1,b1,c1:real);
begin
  a1:=x2-x1;
  b1:=y2-y1;
  c1:=z2-z1;
end;

Procedure Detrm(a1,b1,c1,a2,b2,c2:real;var a3,b3,c3:real);
begin
  a3:=b1*c2-c1*b2;
  b3:=c1*a2-a1*c2;
  c3:=a1*b2-a2*b1;
end;

Procedure LineDraw(n1,n2:Byte);
Begin
  Line(Trunc(Ax*dvx[n1]+Bx),Trunc(Ay*dvy[n1]+By),Trunc(Ax*dvx[n2]+Bx),Trunc(Ay*dvy[n2]+By));
End;

Procedure GranDraw(n1,n2,n3,n4,c:Byte);
var xyz,a1,b1,c1,a2,b2,c2,a3,b3,c3:real;
    crd:array[1..4] of PointType;
begin
  CordVec(dvx[n1],dvy[n1],dvz[n1],dvx[n2],dvy[n2],dvz[n2],a1,b1,c1);
  CordVec(dvx[n1],dvy[n1],dvz[n1],dvx[n4],dvy[n4],dvz[n4],a2,b2,c2);
  Detrm(a1,b1,c1,a2,b2,c2,a3,b3,c3);
  xyz:=a3*dvx[n1]+b3*dvy[n1]+c3*dvz[n1];
  If xyz<0 then
    begin
      a3:=-a3;
      b3:=-b3;
      c3:=-c3;
    end;
  If (C3*10)<0 then
    Begin
      Setfillstyle(1,c);
      Crd[1].x:=Trunc(dvx[n1]*ax+Bx);
      Crd[1].y:=Trunc(dvy[n1]*ay+By);
      Crd[2].x:=Trunc(dvx[n2]*ax+Bx);
      Crd[2].y:=Trunc(dvy[n2]*ay+By);
      Crd[3].x:=Trunc(dvx[n3]*ax+Bx);
      Crd[3].y:=Trunc(dvy[n3]*ay+By);
      Crd[4].x:=Trunc(dvx[n4]*ax+Bx);
      Crd[4].y:=Trunc(dvy[n4]*ay+By);
      FillPoly(4,Crd);
      SetColor(c);
      LineDraw(n1,n2);
      LineDraw(n2,n3);
      LineDraw(n3,n4);
      LineDraw(n4,n1);
    End;
End;

Procedure Set_Angl(paa,pbb:Real);
Var il:Integer;
Begin
  aa:=aa+paa;
  if (aa>2*pi) or (aa<(-2*pi)) then aa:=0;
  bb:=bb+pbb;
  if (bb>2*pi) or (bb<(-2*pi)) then bb:=0;
  For il:=1 to 8 do
      Begin
        dvx[il]:=cos(aa)*vx[il]+sin(aa)*vz[il];
        dvy[il]:=sin(bb)*sin(aa)*vx[il]+cos(bb)*vy[il]+(-sin(bb)*cos(aa))*vz[il];
        dvz[il]:=(-cos(bb)*sin(aa))*vx[il]+sin(bb)*vy[il]+cos(bb)*sin(aa)*vz[il];
      End;
End;

Procedure Kub(x,y:Integer;paa,pbb:Real);
Begin
  bx:=x;
  by:=y;
  GranDraw(1,2,3,4,0);
  GranDraw(1,2,6,5,0);
  GranDraw(2,3,7,6,0);
  GranDraw(3,4,8,7,0);
  GranDraw(4,1,5,8,0);
  GranDraw(5,6,7,8,0);
  Set_Angl(paa,pbb);
  GranDraw(1,2,3,4,245);
  GranDraw(1,2,6,5,249);
  GranDraw(2,3,7,6,248);
  GranDraw(3,4,8,7,246);
  GranDraw(4,1,5,8,247);
  GranDraw(5,6,7,8,250);
End;

Begin
  vx[1]:=1;vx[2]:=1;vx[3]:=1;vx[4]:=1;vx[5]:=-1;vx[6]:=-1;vx[7]:=-1;vx[8]:=-1;
  vy[1]:=1;vy[2]:=-1;vy[3]:=-1;vy[4]:=1;vy[5]:=1;vy[6]:=-1;vy[7]:=-1;vy[8]:=1;
  vz[1]:=1;vz[2]:=1;vz[3]:=-1;vz[4]:=-1;vz[5]:=1;vz[6]:=1;vz[7]:=-1;vz[8]:=-1;
  Bx:=220;
  By:=180;
  aa:=0;
  BB:=0.45;
End.